<?xml version="1.0" encoding="UTF-8"?>
<!--
    * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
    * Copyright (C) 2004-2007 - INRIA - Vincent COUVERT 
    * 
    * This file must be used under the terms of the CeCILL.
    * This source file is licensed as described in the file COPYING, which
    * you should have received as part of this distribution.  The terms
    * are also available at    
    * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
    *
    -->
<refentry xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:svg="http://www.w3.org/2000/svg" xmlns:mml="http://www.w3.org/1998/Math/MathML" xmlns:db="http://docbook.org/ns/docbook" version="5.0-subset Scilab" xml:lang="en" xml:id="mtlb_prod">
  <info>
    <pubdate>$LastChangedDate$</pubdate>
  </info>
  <refnamediv>
    <refname>mtlb_prod</refname>
    <refpurpose>Matlab prod emulation function</refpurpose>
  </refnamediv>
  <refsection>
    <title>Description</title>
    <para>Matlab and Scilab <literal>prod</literal> behave differently in some particular cases:</para>
    <itemizedlist>
      <listitem>
        <para>
        When called with one input: Matlab <literal>prod</literal> threts the values along the first
	non-singleton dimension of input while Scilab <literal>prod</literal> threats all values of input.
        </para>
      </listitem>
      <listitem>
        <para>
        When called with two inputs: Matlab <literal>prod</literal> can be used with second input giving
	a non-existing dimension of first input while Scilab <literal>prod</literal> returns an error message.
        </para>
      </listitem>
    </itemizedlist>
    <para>
    The function <literal>mtlb_prod(A[,dim])</literal> is used by
    <literal>mfile2sci</literal> to replace <literal>prod(A[,dim])</literal> when it was not
    possible to know what were the inputs while porting Matlab code to Scilab. This function will
    determine the correct semantic at run time. If you want to have a
    more efficient code it is possible to replace <literal>mtlb_prod</literal> calls:
    </para>
    <itemizedlist>
      <listitem>
        <para>
        When called with one input, if <literal>A</literal> is an empty matrix, a scalar or a vector,
        <literal>mtlb_prod(A)</literal> may be replaced by <literal>prod(A)</literal>
        </para>
      </listitem>
      <listitem>
        <para>
        When called with one input, if <literal>A</literal> is a not-empty matrix,
        <literal>mtlb_prod(A)</literal> may be replaced by <literal>prod(A,1)</literal>
        </para>
      </listitem>
      <listitem>
        <para>
        When called with one input, if <literal>A</literal> is a multidimensional array,
        <literal>mtlb_prod(A)</literal> may be replaced by <literal>prod(A,firstnonsingleton(A))</literal>
        </para>
      </listitem>
      <listitem>
        <para>
        When called with two inputs, if <literal>dim</literal> is lesser than the number of dimensions of <literal>A</literal>
        <literal>mtlb_prod(A,dim)</literal> may be replaced by <literal>prod(A,dim)</literal>
        </para>
      </listitem>
    </itemizedlist>
    <para>Caution: <literal>mtlb_prod</literal> has not to be used for hand coded functions.</para>
  </refsection>
  <refsection>
    <title>See Also</title>
    <simplelist type="inline">
      <member>
        <link linkend="firstnonsingleton">firstnonsingleton</link>
      </member>
    </simplelist>
  </refsection>
  <refsection>
    <title>Authors</title>
    <simplelist type="vert">
      <member>V.C.</member>
    </simplelist>
  </refsection>
</refentry>
